use core::system::System;
use core::Clock;
use simplelog::*;
use std::fs::File;
use std::thread::sleep;
use std::time::Duration;

const ROM_PATH: &'static str = "./roms/dk.nes";

fn main() {
    CombinedLogger::init(vec![
        TermLogger::new(
            LevelFilter::Info,
            Config::default(),
            TerminalMode::Mixed,
            ColorChoice::Auto,
        ),
        WriteLogger::new(
            LevelFilter::Debug,
            Config::default(),
            File::create("./logs/latest.log").unwrap(),
        ),
    ])
    .unwrap();

    let mut system = System::new();
    system.insert_rom(ROM_PATH).expect("Failed to insert ROM");

    loop {
        system.cycle();

        // TODO: Inaccurate, ~60hz
        sleep(Duration::from_millis(16));
    }
}
